diff -uNr openmp-3.5.0.src/runtime/CMakeLists.txt openmp-3.5.0.src.r219214/runtime/CMakeLists.txt
--- openmp-3.5.0.src/runtime/CMakeLists.txt	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/CMakeLists.txt	2014-10-24 19:58:40.000000000 -0400
@@ -238,8 +238,18 @@
 # - these predefined linker flags should work for Windows, Mac, and True Linux for the most popular compilers/linkers
 set(USE_PREDEFINED_LINKER_FLAGS true CACHE BOOL "Should the build use the predefined linker flags in CommonFlags.cmake?")
 
+# - On multinode systems, larger alignment is desired to avoid false sharing
+set(USE_INTERNODE_ALIGNMENT false CACHE BOOL "Should larger alignment (4096 bytes) be used for some locks and data structures?")
+
+# - libgomp drop-in compatibility
+if(${LINUX} AND NOT ${PPC64})
+    set(USE_VERSION_SYMBOLS true CACHE BOOL "Should version symbols be used? These provide binary compatibility with libgomp.")
+else()
+    set(USE_VERSION_SYMBOLS false CACHE BOOL "Should version symbols be used? These provide binary compatibility with libgomp.")
+endif()
+
 # - TSX based locks have __asm code which can be troublesome for some compilers.  This feature is also x86 specific.
-if({${IA32} OR ${INTEL64})
+if(${IA32} OR ${INTEL64})
     set(USE_ADAPTIVE_LOCKS true CACHE BOOL "Should TSX-based lock be compiled (adaptive lock in kmp_lock.cpp).  These are x86 specific.")
 else()
     set(USE_ADAPTIVE_LOCKS false CACHE BOOL "Should TSX-based lock be compiled (adaptive lock in kmp_lock.cpp).  These are x86 specific.")
diff -uNr openmp-3.5.0.src/runtime/cmake/BuildPLRules.cmake openmp-3.5.0.src.r219214/runtime/cmake/BuildPLRules.cmake
--- openmp-3.5.0.src/runtime/cmake/BuildPLRules.cmake	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/cmake/BuildPLRules.cmake	2014-10-24 19:58:40.000000000 -0400
@@ -1,3 +1,14 @@
+#
+#//===----------------------------------------------------------------------===//
+#//
+#//                     The LLVM Compiler Infrastructure
+#//
+#// This file is dual licensed under the MIT and the University of Illinois Open
+#// Source Licenses. See LICENSE.txt for details.
+#//
+#//===----------------------------------------------------------------------===//
+#
+
 ###############################################################################
 # This file contains additional build rules that correspond to build.pl's rules
 # Building libiomp5.dbg is linux only, Windows will build libiomp5md.dll.pdb
diff -uNr openmp-3.5.0.src/runtime/cmake/Clang/AsmFlags.cmake openmp-3.5.0.src.r219214/runtime/cmake/Clang/AsmFlags.cmake
--- openmp-3.5.0.src/runtime/cmake/Clang/AsmFlags.cmake	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/cmake/Clang/AsmFlags.cmake	2014-10-24 19:58:40.000000000 -0400
@@ -1,3 +1,14 @@
+#
+#//===----------------------------------------------------------------------===//
+#//
+#//                     The LLVM Compiler Infrastructure
+#//
+#// This file is dual licensed under the MIT and the University of Illinois Open
+#// Source Licenses. See LICENSE.txt for details.
+#//
+#//===----------------------------------------------------------------------===//
+#
+
 # This file holds Clang (clang/clang++) specific compiler dependent flags
 # The flag types are:
 #   1) Assembly flags
diff -uNr openmp-3.5.0.src/runtime/cmake/Clang/CFlags.cmake openmp-3.5.0.src.r219214/runtime/cmake/Clang/CFlags.cmake
--- openmp-3.5.0.src/runtime/cmake/Clang/CFlags.cmake	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/cmake/Clang/CFlags.cmake	2014-10-24 19:58:40.000000000 -0400
@@ -1,3 +1,14 @@
+#
+#//===----------------------------------------------------------------------===//
+#//
+#//                     The LLVM Compiler Infrastructure
+#//
+#// This file is dual licensed under the MIT and the University of Illinois Open
+#// Source Licenses. See LICENSE.txt for details.
+#//
+#//===----------------------------------------------------------------------===//
+#
+
 # This file holds Clang (clang/clang++) specific compiler dependent flags
 # The flag types are:
 #   1) C/C++ Compiler flags
@@ -19,6 +30,7 @@
     endif()
     append_c_and_cxx_flags("-Wno-unused-value") # Don't warn about unused values
     append_c_and_cxx_flags("-Wno-switch") # Don't warn about switch statements that don't cover entire range of values
+    append_c_and_cxx_flags("-Wno-deprecated-register") # Don't warn about using register keyword
     set(${input_c_flags}   ${${input_c_flags}}   "${local_c_flags}" PARENT_SCOPE)
     set(${input_cxx_flags} ${${input_cxx_flags}} "${local_cxx_flags}" PARENT_SCOPE)
 endfunction()
diff -uNr openmp-3.5.0.src/runtime/cmake/CommonFlags.cmake openmp-3.5.0.src.r219214/runtime/cmake/CommonFlags.cmake
--- openmp-3.5.0.src/runtime/cmake/CommonFlags.cmake	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/cmake/CommonFlags.cmake	2014-10-24 19:58:40.000000000 -0400
@@ -1,3 +1,14 @@
+#
+#//===----------------------------------------------------------------------===//
+#//
+#//                     The LLVM Compiler Infrastructure
+#//
+#// This file is dual licensed under the MIT and the University of Illinois Open
+#// Source Licenses. See LICENSE.txt for details.
+#//
+#//===----------------------------------------------------------------------===//
+#
+
 # This file holds the common flags independent of compiler
 # The flag types are: 
 #   1) Assembly flags          (append_asm_flags_common)
@@ -71,22 +82,21 @@
     set(local_ld_flags)
     set(local_ld_flags_libs)
 
-    #################################
-    # Windows linker flags
-    if(${WINDOWS}) 
-
-    ##################
-    # MAC linker flags
-    elseif(${MAC})
-        if(${USE_PREDEFINED_LINKER_FLAGS})
+    if(${USE_PREDEFINED_LINKER_FLAGS})
+
+        #################################
+        # Windows linker flags
+        if(${WINDOWS}) 
+
+        ##################
+        # MAC linker flags
+        elseif(${MAC})
             append_linker_flags("-single_module")
             append_linker_flags("-current_version ${version}.0")
             append_linker_flags("-compatibility_version ${version}.0")
-        endif()
-    #####################################################################################
-    # Intel(R) Many Integrated Core Architecture (Intel(R) MIC Architecture) linker flags
-    elseif(${MIC})
-        if(${USE_PREDEFINED_LINKER_FLAGS})
+        #####################################################################################
+        # Intel(R) Many Integrated Core Architecture (Intel(R) MIC Architecture) linker flags
+        elseif(${MIC})
             append_linker_flags("-Wl,-x")
             append_linker_flags("-Wl,--warn-shared-textrel") #  Warn if the linker adds a DT_TEXTREL to a shared object.
             append_linker_flags("-Wl,--as-needed")
@@ -98,13 +108,11 @@
             if(${STATS_GATHERING})
                 append_linker_flags_library("-Wl,-lstdc++") # link in standard c++ library (stats-gathering needs it)
             endif()
-        endif()
-    #########################
-    # Unix based linker flags
-    else()
-        # For now, always include --version-script flag on Unix systems.
-        append_linker_flags("-Wl,--version-script=${src_dir}/exports_so.txt") # Use exports_so.txt as version script to create versioned symbols for ELF libraries
-        if(${USE_PREDEFINED_LINKER_FLAGS})
+        #########################
+        # Unix based linker flags
+        else()
+            # For now, always include --version-script flag on Unix systems.
+            append_linker_flags("-Wl,--version-script=${src_dir}/exports_so.txt") # Use exports_so.txt as version script to create versioned symbols for ELF libraries
             append_linker_flags("-Wl,-z,noexecstack") #  Marks the object as not requiring executable stack.
             append_linker_flags("-Wl,--as-needed")    #  Only adds library dependencies as they are needed. (if libiomp5 actually uses a function from the library, then add it)
             if(NOT ${STUBS_LIBRARY})
@@ -117,8 +125,9 @@
                     append_linker_flags_library("-Wl,-ldl") # link in libdl (dynamic loader library)
                 endif()
             endif()
-        endif() # if(${USE_PREDEFINED_LINKER_FLAGS})
-    endif() # if(${OPERATING_SYSTEM}) ...
+        endif() # if(${OPERATING_SYSTEM}) ...
+
+    endif() # USE_PREDEFINED_LINKER_FLAGS
 
     set(${input_ld_flags}      "${${input_ld_flags}}"      "${local_ld_flags}"      "${USER_LD_FLAGS}"     PARENT_SCOPE)
     set(${input_ld_flags_libs} "${${input_ld_flags_libs}}" "${local_ld_flags_libs}" "${USER_LD_LIB_FLAGS}" PARENT_SCOPE)
diff -uNr openmp-3.5.0.src/runtime/cmake/Definitions.cmake openmp-3.5.0.src.r219214/runtime/cmake/Definitions.cmake
--- openmp-3.5.0.src/runtime/cmake/Definitions.cmake	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/cmake/Definitions.cmake	2014-10-24 19:58:40.000000000 -0400
@@ -42,6 +42,10 @@
     endif()
     append_definitions("-D INTEL_ITTNOTIFY_PREFIX=__kmp_itt_")
 
+    if(${USE_VERSION_SYMBOLS})
+        append_definitions("-D KMP_USE_VERSION_SYMBOLS")
+    endif()
+
     #####################
     # Windows definitions
     if(${WINDOWS})
@@ -133,6 +137,11 @@
         append_definitions("-D KMP_USE_ADAPTIVE_LOCKS=0")
         append_definitions("-D KMP_DEBUG_ADAPTIVE_LOCKS=0")
     endif()
+    if(${USE_INTERNODE_ALIGNMENT})
+        append_definitions("-D KMP_USE_INTERNODE_ALIGNMENT=1")
+    else()
+        append_definitions("-D KMP_USE_INTERNODE_ALIGNMENT=0")
+    endif()
     set(${input_cpp_flags} "${${input_cpp_flags}}" "${local_cpp_flags}" "${USER_CPP_FLAGS}" "$ENV{CPPFLAGS}" PARENT_SCOPE)
 endfunction()
 
diff -uNr openmp-3.5.0.src/runtime/cmake/GNU/AsmFlags.cmake openmp-3.5.0.src.r219214/runtime/cmake/GNU/AsmFlags.cmake
--- openmp-3.5.0.src/runtime/cmake/GNU/AsmFlags.cmake	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/cmake/GNU/AsmFlags.cmake	2014-10-24 19:58:40.000000000 -0400
@@ -1,3 +1,14 @@
+#
+#//===----------------------------------------------------------------------===//
+#//
+#//                     The LLVM Compiler Infrastructure
+#//
+#// This file is dual licensed under the MIT and the University of Illinois Open
+#// Source Licenses. See LICENSE.txt for details.
+#//
+#//===----------------------------------------------------------------------===//
+#
+
 # This file holds GNU (gcc/g++) specific compiler dependent flags
 # The flag types are:
 #   1) Assembly flags
diff -uNr openmp-3.5.0.src/runtime/cmake/GNU/CFlags.cmake openmp-3.5.0.src.r219214/runtime/cmake/GNU/CFlags.cmake
--- openmp-3.5.0.src/runtime/cmake/GNU/CFlags.cmake	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/cmake/GNU/CFlags.cmake	2014-10-24 19:58:40.000000000 -0400
@@ -1,3 +1,14 @@
+#
+#//===----------------------------------------------------------------------===//
+#//
+#//                     The LLVM Compiler Infrastructure
+#//
+#// This file is dual licensed under the MIT and the University of Illinois Open
+#// Source Licenses. See LICENSE.txt for details.
+#//
+#//===----------------------------------------------------------------------===//
+#
+
 # This file holds GNU (gcc/g++) specific compiler dependent flags
 # The flag types are:
 #   2) C/C++ Compiler flags
diff -uNr openmp-3.5.0.src/runtime/cmake/GNU/FortranFlags.cmake openmp-3.5.0.src.r219214/runtime/cmake/GNU/FortranFlags.cmake
--- openmp-3.5.0.src/runtime/cmake/GNU/FortranFlags.cmake	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/cmake/GNU/FortranFlags.cmake	2014-10-24 19:58:40.000000000 -0400
@@ -1,3 +1,14 @@
+#
+#//===----------------------------------------------------------------------===//
+#//
+#//                     The LLVM Compiler Infrastructure
+#//
+#// This file is dual licensed under the MIT and the University of Illinois Open
+#// Source Licenses. See LICENSE.txt for details.
+#//
+#//===----------------------------------------------------------------------===//
+#
+
 # This file holds GNU (gcc/g++) specific compiler dependent flags
 # The flag types are:
 #   1) Fortran Compiler flags
diff -uNr openmp-3.5.0.src/runtime/cmake/Intel/AsmFlags.cmake openmp-3.5.0.src.r219214/runtime/cmake/Intel/AsmFlags.cmake
--- openmp-3.5.0.src/runtime/cmake/Intel/AsmFlags.cmake	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/cmake/Intel/AsmFlags.cmake	2014-10-24 19:58:40.000000000 -0400
@@ -1,3 +1,14 @@
+#
+#//===----------------------------------------------------------------------===//
+#//
+#//                     The LLVM Compiler Infrastructure
+#//
+#// This file is dual licensed under the MIT and the University of Illinois Open
+#// Source Licenses. See LICENSE.txt for details.
+#//
+#//===----------------------------------------------------------------------===//
+#
+
 # This file holds Intel(R) C Compiler / Intel(R) C++ Compiler / Intel(R) Fortran Compiler (icc/icpc/icl.exe/ifort) dependent flags
 # The flag types are:
 #   1) Assembly flags
diff -uNr openmp-3.5.0.src/runtime/cmake/Intel/CFlags.cmake openmp-3.5.0.src.r219214/runtime/cmake/Intel/CFlags.cmake
--- openmp-3.5.0.src/runtime/cmake/Intel/CFlags.cmake	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/cmake/Intel/CFlags.cmake	2014-10-24 19:58:40.000000000 -0400
@@ -1,3 +1,14 @@
+#
+#//===----------------------------------------------------------------------===//
+#//
+#//                     The LLVM Compiler Infrastructure
+#//
+#// This file is dual licensed under the MIT and the University of Illinois Open
+#// Source Licenses. See LICENSE.txt for details.
+#//
+#//===----------------------------------------------------------------------===//
+#
+
 # This file holds Intel(R) C Compiler / Intel(R) C++ Compiler / Intel(R) Fortran Compiler (icc/icpc/icl.exe/ifort) dependent flags
 # The flag types are:
 #   2) C/C++ Compiler flags
@@ -41,7 +52,6 @@
         endif()
     else()
         append_c_and_cxx_flags("-Wsign-compare") # warn on sign comparisons
-        append_c_and_cxx_flags("-Werror") # Changes all warnings to errors.
         append_c_and_cxx_flags("-Qoption,cpp,--extended_float_types") # Enabled _Quad type.
         append_c_and_cxx_flags("-fno-exceptions") # Exception handling table generation is disabled.
         append_c_and_cxx_flags("-x c++") # Compile C files as C++ files
diff -uNr openmp-3.5.0.src/runtime/cmake/Intel/FortranFlags.cmake openmp-3.5.0.src.r219214/runtime/cmake/Intel/FortranFlags.cmake
--- openmp-3.5.0.src/runtime/cmake/Intel/FortranFlags.cmake	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/cmake/Intel/FortranFlags.cmake	2014-10-24 19:58:40.000000000 -0400
@@ -1,3 +1,14 @@
+#
+#//===----------------------------------------------------------------------===//
+#//
+#//                     The LLVM Compiler Infrastructure
+#//
+#// This file is dual licensed under the MIT and the University of Illinois Open
+#// Source Licenses. See LICENSE.txt for details.
+#//
+#//===----------------------------------------------------------------------===//
+#
+
 # This file holds Intel(R) C Compiler / Intel(R) C++ Compiler / Intel(R) Fortran Compiler (icc/icpc/icl.exe/ifort) dependent flags
 # The flag types are:
 #   1) Fortran Compiler flags
@@ -17,12 +28,20 @@
         append_fort_flags("-GS")
         append_fort_flags("-DynamicBase")
         append_fort_flags("-Zi")
+        # On Linux and Windows Intel(R) 64 architecture we need offload attribute
+        # for all Fortran entries in order to support OpenMP function calls inside device contructs
+        if(${INTEL64})
+            append_fort_flags("/Qoffload-attribute-target:mic")
+        endif()
     else()
         if(${MIC})
             append_fort_flags("-mmic")
         endif()
         if(NOT ${MAC})
             append_fort_flags("-sox")
+            if(${INTEL64} AND ${LINUX})
+                append_fort_flags("-offload-attribute-target=mic")
+            endif()
         endif()
     endif()
     set(${input_fort_flags} ${${input_fort_flags}} "${local_fort_flags}" PARENT_SCOPE)
diff -uNr openmp-3.5.0.src/runtime/cmake/MSVC/AsmFlags.cmake openmp-3.5.0.src.r219214/runtime/cmake/MSVC/AsmFlags.cmake
--- openmp-3.5.0.src/runtime/cmake/MSVC/AsmFlags.cmake	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/cmake/MSVC/AsmFlags.cmake	2014-10-24 19:58:40.000000000 -0400
@@ -1,3 +1,14 @@
+#
+#//===----------------------------------------------------------------------===//
+#//
+#//                     The LLVM Compiler Infrastructure
+#//
+#// This file is dual licensed under the MIT and the University of Illinois Open
+#// Source Licenses. See LICENSE.txt for details.
+#//
+#//===----------------------------------------------------------------------===//
+#
+
 # This file holds Microsoft Visual Studio dependent flags
 # The flag types are:
 #   1) Assembly flags
diff -uNr openmp-3.5.0.src/runtime/cmake/MSVC/CFlags.cmake openmp-3.5.0.src.r219214/runtime/cmake/MSVC/CFlags.cmake
--- openmp-3.5.0.src/runtime/cmake/MSVC/CFlags.cmake	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/cmake/MSVC/CFlags.cmake	2014-10-24 19:58:40.000000000 -0400
@@ -1,3 +1,14 @@
+#
+#//===----------------------------------------------------------------------===//
+#//
+#//                     The LLVM Compiler Infrastructure
+#//
+#// This file is dual licensed under the MIT and the University of Illinois Open
+#// Source Licenses. See LICENSE.txt for details.
+#//
+#//===----------------------------------------------------------------------===//
+#
+
 # This file holds Microsoft Visual Studio dependent flags
 # The flag types are:
 #   1) C/C++ Compiler flags
diff -uNr openmp-3.5.0.src/runtime/cmake/MicroTests.cmake openmp-3.5.0.src.r219214/runtime/cmake/MicroTests.cmake
--- openmp-3.5.0.src/runtime/cmake/MicroTests.cmake	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/cmake/MicroTests.cmake	2014-10-24 19:58:40.000000000 -0400
@@ -1,3 +1,14 @@
+#
+#//===----------------------------------------------------------------------===//
+#//
+#//                     The LLVM Compiler Infrastructure
+#//
+#// This file is dual licensed under the MIT and the University of Illinois Open
+#// Source Licenses. See LICENSE.txt for details.
+#//
+#//===----------------------------------------------------------------------===//
+#
+
 ######################################################
 # MICRO TESTS
 # The following micro-tests are small tests to perform on 
@@ -219,15 +230,14 @@
         set(td_exp libc.so.7 libthr.so.3 libunwind.so.5)
     elseif(${LINUX})
         set(td_exp libdl.so.2,libgcc_s.so.1)
-        if(NOT ${IA32} AND NOT ${INTEL64})
-            set(td_exp ${td_exp},libffi.so.6,libffi.so.5)
-        endif()
         if(${IA32})
             set(td_exp ${td_exp},libc.so.6,ld-linux.so.2)  
         elseif(${INTEL64})
             set(td_exp ${td_exp},libc.so.6,ld-linux-x86-64.so.2)  
         elseif(${ARM})
-            set(td_exp ${td_exp},libc.so.6,ld-linux-armhf.so.3)  
+            set(td_exp ${td_exp},libffi.so.6,libffi.so.5,libc.so.6,ld-linux-armhf.so.3)  
+        elseif(${PPC64})
+            set(td_exp ${td_exp},libc.so.6,ld64.so.1)  
         endif()
         if(${STD_CPP_LIB})
             set(td_exp ${td_exp},libstdc++.so.6)
diff -uNr openmp-3.5.0.src/runtime/cmake/SourceFiles.cmake openmp-3.5.0.src.r219214/runtime/cmake/SourceFiles.cmake
--- openmp-3.5.0.src/runtime/cmake/SourceFiles.cmake	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/cmake/SourceFiles.cmake	2014-10-24 19:58:40.000000000 -0400
@@ -69,7 +69,8 @@
 function(set_cpp_files input_cpp_source_files) 
     set(local_cpp_source_files "")
     if(NOT ${STUBS_LIBRARY})
-        #append_cpp_source_file("kmp_barrier.cpp")
+        append_cpp_source_file("kmp_barrier.cpp")
+        append_cpp_source_file("kmp_wait_release.cpp")
         append_cpp_source_file("kmp_affinity.cpp")
         append_cpp_source_file("kmp_dispatch.cpp")
         append_cpp_source_file("kmp_lock.cpp")
@@ -78,10 +79,10 @@
             append_cpp_source_file("kmp_taskdeps.cpp")
             append_cpp_source_file("kmp_cancel.cpp")
         endif()
-        #if(${STATS_GATHERING})
-        #   append_cpp_source_file("kmp_stats.cpp")
-        #    append_cpp_source_file("kmp_stats_timing.cpp")
-        #endif()
+        if(${STATS_GATHERING})
+            append_cpp_source_file("kmp_stats.cpp")
+            append_cpp_source_file("kmp_stats_timing.cpp")
+        endif()
     endif()
 
     set(${input_cpp_source_files} "${local_cpp_source_files}" PARENT_SCOPE)
diff -uNr openmp-3.5.0.src/runtime/doc/doxygen/config openmp-3.5.0.src.r219214/runtime/doc/doxygen/config
--- openmp-3.5.0.src/runtime/doc/doxygen/config	2013-09-27 06:38:44.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/doc/doxygen/config	2014-10-24 19:58:40.000000000 -0400
@@ -1539,7 +1539,7 @@
 # undefined via #undef or recursively expanded use the := operator
 # instead of the = operator.
 
-PREDEFINED             = OMP_30_ENABLED=1, OMP_40_ENABLED=1
+PREDEFINED             = OMP_30_ENABLED=1, OMP_40_ENABLED=1, KMP_STATS_ENABLED=1
 
 # If the MACRO_EXPANSION and EXPAND_ONLY_PREDEF tags are set to YES then
 # this tag can be used to specify a list of macro names that should be expanded.
diff -uNr openmp-3.5.0.src/runtime/doc/doxygen/libomp_interface.h openmp-3.5.0.src.r219214/runtime/doc/doxygen/libomp_interface.h
--- openmp-3.5.0.src/runtime/doc/doxygen/libomp_interface.h	2013-09-27 06:38:44.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/doc/doxygen/libomp_interface.h	2014-10-24 19:58:40.000000000 -0400
@@ -208,6 +208,7 @@
  - @ref THREADPRIVATE functions to support thread private data, copyin etc
  - @ref SYNCHRONIZATION functions to support `omp critical`, `omp barrier`, `omp master`, reductions etc
  - @ref ATOMIC_OPS functions to support atomic operations
+ - @ref STATS_GATHERING macros to support developer profiling of libiomp5
  - Documentation on tasking has still to be written...
 
 @section SEC_EXAMPLES Examples
@@ -319,8 +320,29 @@
 @defgroup THREADPRIVATE Thread private data support
 These functions support copyin/out and thread private data.
 
+@defgroup STATS_GATHERING Statistics Gathering from OMPTB
+These macros support profiling the libiomp5 library.  Use --stats=on when building with build.pl to enable
+and then use the KMP_* macros to profile (through counts or clock ticks) libiomp5 during execution of an OpenMP program.
+
+@section sec_stats_env_vars Environment Variables
+
+This section describes the environment variables relevent to stats-gathering in libiomp5
+
+@code
+KMP_STATS_FILE
+@endcode
+This environment variable is set to an output filename that will be appended *NOT OVERWRITTEN* if it exists.  If this environment variable is undefined, the statistics will be output to stderr
+
+@code
+KMP_STATS_THREADS
+@endcode
+This environment variable indicates to print thread-specific statistics as well as aggregate statistics.  Each thread's statistics will be shown as well as the collective sum of all threads.  The values "true", "on", "1", "yes" will all indicate to print per thread statistics.
+
 @defgroup TASKING Tasking support
-These functions support are used to implement tasking constructs.
+These functions support tasking constructs.
+
+@defgroup USER User visible functions
+These functions can be called directly by the user, but are runtime library specific, rather than being OpenMP interfaces.
 
 */
 
diff -uNr openmp-3.5.0.src/runtime/src/defs.mk openmp-3.5.0.src.r219214/runtime/src/defs.mk
--- openmp-3.5.0.src/runtime/src/defs.mk	2013-09-27 06:38:44.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/defs.mk	2014-10-24 19:58:41.000000000 -0400
@@ -1,6 +1,6 @@
 # defs.mk
-# $Revision: 42061 $
-# $Date: 2013-02-28 16:36:24 -0600 (Thu, 28 Feb 2013) $
+# $Revision: 42951 $
+# $Date: 2014-01-21 14:41:41 -0600 (Tue, 21 Jan 2014) $
 
 #
 #//===----------------------------------------------------------------------===//
diff -uNr openmp-3.5.0.src/runtime/src/dllexports openmp-3.5.0.src.r219214/runtime/src/dllexports
--- openmp-3.5.0.src/runtime/src/dllexports	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/dllexports	2014-10-24 19:58:41.000000000 -0400
@@ -161,10 +161,8 @@
     # Regular entry points
         __kmp_wait_yield_4
         __kmp_wait_yield_8
-        __kmp_wait_sleep
         __kmp_fork_call
         __kmp_invoke_microtask
-        __kmp_release
         __kmp_launch_monitor
         __kmp_launch_worker
         __kmp_reap_monitor
@@ -192,6 +190,14 @@
             _You_must_link_with_Microsoft_OpenMP_library  DATA
         %endif
 
+        __kmp_wait_32
+        __kmp_wait_64
+        __kmp_wait_oncore
+        __kmp_release_32
+        __kmp_release_64
+        __kmp_release_oncore
+
+
 #    VT_getthid                              1
 #    vtgthid                                 2
 
@@ -360,6 +366,18 @@
         __kmpc_cancel                       244
         __kmpc_cancellationpoint            245
         __kmpc_cancel_barrier               246
+        __kmpc_dist_for_static_init_4       247
+        __kmpc_dist_for_static_init_4u      248
+        __kmpc_dist_for_static_init_8       249
+        __kmpc_dist_for_static_init_8u      250
+        __kmpc_dist_dispatch_init_4         251
+        __kmpc_dist_dispatch_init_4u        252
+        __kmpc_dist_dispatch_init_8         253
+        __kmpc_dist_dispatch_init_8u        254
+        __kmpc_team_static_init_4           255
+        __kmpc_team_static_init_4u          256
+        __kmpc_team_static_init_8           257
+        __kmpc_team_static_init_8u          258
     %endif # OMP_40
 %endif
 
diff -uNr openmp-3.5.0.src/runtime/src/extractExternal.cpp openmp-3.5.0.src.r219214/runtime/src/extractExternal.cpp
--- openmp-3.5.0.src/runtime/src/extractExternal.cpp	2014-02-24 05:40:15.000000000 -0500
+++ openmp-3.5.0.src.r219214/runtime/src/extractExternal.cpp	2014-10-24 19:58:41.000000000 -0400
@@ -1,7 +1,7 @@
 /*
  * extractExternal.cpp
- * $Revision: 42181 $
- * $Date: 2013-03-26 15:04:45 -0500 (Tue, 26 Mar 2013) $
+ * $Revision: 43084 $
+ * $Date: 2014-04-15 09:15:14 -0500 (Tue, 15 Apr 2014) $
  */
 
 
diff -uNr openmp-3.5.0.src/runtime/src/include/25/iomp.h.var openmp-3.5.0.src.r219214/runtime/src/include/25/iomp.h.var
--- openmp-3.5.0.src/runtime/src/include/25/iomp.h.var	2013-09-27 06:38:44.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/include/25/iomp.h.var	2014-10-24 19:58:40.000000000 -0400
@@ -1,7 +1,7 @@
 /*
  * include/25/iomp.h.var
- * $Revision: 42061 $
- * $Date: 2013-02-28 16:36:24 -0600 (Thu, 28 Feb 2013) $
+ * $Revision: 42951 $
+ * $Date: 2014-01-21 14:41:41 -0600 (Tue, 21 Jan 2014) $
  */
 
 
diff -uNr openmp-3.5.0.src/runtime/src/include/25/iomp_lib.h.var openmp-3.5.0.src.r219214/runtime/src/include/25/iomp_lib.h.var
--- openmp-3.5.0.src/runtime/src/include/25/iomp_lib.h.var	2013-09-27 06:38:44.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/include/25/iomp_lib.h.var	2014-10-24 19:58:40.000000000 -0400
@@ -1,6 +1,6 @@
 ! include/25/iomp_lib.h.var
-! $Revision: 42061 $
-! $Date: 2013-02-28 16:36:24 -0600 (Thu, 28 Feb 2013) $
+! $Revision: 42951 $
+! $Date: 2014-01-21 14:41:41 -0600 (Tue, 21 Jan 2014) $
 
 !
 !//===----------------------------------------------------------------------===//
diff -uNr openmp-3.5.0.src/runtime/src/include/25/omp.h.var openmp-3.5.0.src.r219214/runtime/src/include/25/omp.h.var
--- openmp-3.5.0.src/runtime/src/include/25/omp.h.var	2013-09-27 06:38:44.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/include/25/omp.h.var	2014-10-24 19:58:40.000000000 -0400
@@ -1,7 +1,7 @@
 /*
  * include/25/omp.h.var
- * $Revision: 42061 $
- * $Date: 2013-02-28 16:36:24 -0600 (Thu, 28 Feb 2013) $
+ * $Revision: 42951 $
+ * $Date: 2014-01-21 14:41:41 -0600 (Tue, 21 Jan 2014) $
  */
 
 
diff -uNr openmp-3.5.0.src/runtime/src/include/25/omp_lib.f.var openmp-3.5.0.src.r219214/runtime/src/include/25/omp_lib.f.var
--- openmp-3.5.0.src/runtime/src/include/25/omp_lib.f.var	2013-09-27 06:38:44.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/include/25/omp_lib.f.var	2014-10-24 19:58:40.000000000 -0400
@@ -1,6 +1,6 @@
 ! include/25/omp_lib.f.var
-! $Revision: 42181 $
-! $Date: 2013-03-26 15:04:45 -0500 (Tue, 26 Mar 2013) $
+! $Revision: 42951 $
+! $Date: 2014-01-21 14:41:41 -0600 (Tue, 21 Jan 2014) $
 
 !
 !//===----------------------------------------------------------------------===//
@@ -314,7 +314,7 @@
 !dec$   else
 
 !***
-!*** On Windows* OS IA-32 architecture, the Fortran entry points have an 
+!*** On Windows* OS IA-32 architecture, the Fortran entry points have an
 !*** underscore prepended.
 !***
 
diff -uNr openmp-3.5.0.src/runtime/src/include/25/omp_lib.f90.var openmp-3.5.0.src.r219214/runtime/src/include/25/omp_lib.f90.var
--- openmp-3.5.0.src/runtime/src/include/25/omp_lib.f90.var	2013-09-27 06:38:44.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/include/25/omp_lib.f90.var	2014-10-24 19:58:40.000000000 -0400
@@ -1,6 +1,6 @@
 ! include/25/omp_lib.f90.var
-! $Revision: 42061 $
-! $Date: 2013-02-28 16:36:24 -0600 (Thu, 28 Feb 2013) $
+! $Revision: 42951 $
+! $Date: 2014-01-21 14:41:41 -0600 (Tue, 21 Jan 2014) $
 
 !
 !//===----------------------------------------------------------------------===//
diff -uNr openmp-3.5.0.src/runtime/src/include/25/omp_lib.h.var openmp-3.5.0.src.r219214/runtime/src/include/25/omp_lib.h.var
--- openmp-3.5.0.src/runtime/src/include/25/omp_lib.h.var	2013-09-27 06:38:44.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/include/25/omp_lib.h.var	2014-10-24 19:58:40.000000000 -0400
@@ -1,6 +1,6 @@
 ! include/25/omp_lib.h.var
-! $Revision: 42181 $
-! $Date: 2013-03-26 15:04:45 -0500 (Tue, 26 Mar 2013) $
+! $Revision: 42951 $
+! $Date: 2014-01-21 14:41:41 -0600 (Tue, 21 Jan 2014) $
 
 !
 !//===----------------------------------------------------------------------===//
@@ -301,7 +301,7 @@
 !dec$   else
 
 !***
-!*** On Windows* OS IA-32 architecture, the Fortran entry points have an 
+!*** On Windows* OS IA-32 architecture, the Fortran entry points have an
 !*** underscore prepended.
 !***
 
diff -uNr openmp-3.5.0.src/runtime/src/include/30/iomp.h.var openmp-3.5.0.src.r219214/runtime/src/include/30/iomp.h.var
--- openmp-3.5.0.src/runtime/src/include/30/iomp.h.var	2013-09-27 06:38:44.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/include/30/iomp.h.var	2014-10-24 19:58:40.000000000 -0400
@@ -1,7 +1,7 @@
 /*
  * include/30/iomp.h.var
- * $Revision: 42061 $
- * $Date: 2013-02-28 16:36:24 -0600 (Thu, 28 Feb 2013) $
+ * $Revision: 42951 $
+ * $Date: 2014-01-21 14:41:41 -0600 (Tue, 21 Jan 2014) $
  */
 
 
diff -uNr openmp-3.5.0.src/runtime/src/include/30/iomp_lib.h.var openmp-3.5.0.src.r219214/runtime/src/include/30/iomp_lib.h.var
--- openmp-3.5.0.src/runtime/src/include/30/iomp_lib.h.var	2013-09-27 06:38:44.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/include/30/iomp_lib.h.var	2014-10-24 19:58:40.000000000 -0400
@@ -1,6 +1,6 @@
 ! include/30/iomp_lib.h.var
-! $Revision: 42061 $
-! $Date: 2013-02-28 16:36:24 -0600 (Thu, 28 Feb 2013) $
+! $Revision: 42951 $
+! $Date: 2014-01-21 14:41:41 -0600 (Tue, 21 Jan 2014) $
 
 !
 !//===----------------------------------------------------------------------===//
